//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma link "SightPt"
#pragma link "sampreg"
#pragma resource "*.dfm"
TForm1 *Form1;
//--------------------------------------------------------------------------- 
//char * __fastcall StrDistance()
AnsiString __fastcall StrDistance()
{
float rx,ry,d;
char buf[40];
rx = Form1->SightPointRed->X - Form1->SightPointBlack->X;
ry = Form1->SightPointRed->Y - Form1->SightPointBlack->Y;
d = sqrt(rx*rx + ry*ry);
sprintf(buf,"%.2f",d);
return(buf);
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
SpinEditRedX->Value = SightPointRed->X;
SpinEditRedY->Value = SightPointRed->Y;
SpinEditBlackX->Value = SightPointBlack->Centre.x;
SpinEditBlackY->Value = SightPointBlack->Centre.y;
SpinEditRedX->Increment = SpinEditRedStep->Value;	
SpinEditRedY->Increment = SpinEditRedStep->Value;
SpinEditBlackX->Increment = SpinEditBlackStep->Value;	
SpinEditBlackY->Increment = SpinEditBlackStep->Value;
EditDist->Text = StrDistance();
SavX1 = SightPointBlack->Centre.x;
SavY1 = SightPointBlack->Centre.y;
SavX2 = SightPointRed->X;
SavY2 = SightPointRed->Y;
}
//--------------------------------------------------------------------------- 
void __fastcall TForm1::SpinEditRedXChange(TObject *Sender)
{
SightPointRed->X = SpinEditRedX->Value;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpinEditRedYChange(TObject *Sender)
{
SightPointRed->Y = SpinEditRedY->Value;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpinEditRedStepChange(TObject *Sender)
{
SpinEditRedX->Increment = SpinEditRedStep->Value;	
SpinEditRedY->Increment = SpinEditRedStep->Value;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpinEditBlackXChange(TObject *Sender)
{
TPoint pt;
pt.x = SpinEditBlackX->Value;
pt.y = SightPointBlack->Centre.y;
SightPointBlack->Centre = pt;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpinEditBlackYChange(TObject *Sender)
{
TPoint pt;
pt.x = SightPointBlack->Centre.x;
pt.y = SpinEditBlackY->Value;
SightPointBlack->Centre = pt;		
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpinEditBlackStepChange(TObject *Sender)
{
SpinEditBlackX->Increment = SpinEditBlackStep->Value;	
SpinEditBlackY->Increment = SpinEditBlackStep->Value;		
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SightPointRedChange(TObject *Sender, int &NewX,
	int &NewY)
{
SpinEditRedX->Value = NewX;	
SpinEditRedY->Value = NewY;
EditDist->Text = StrDistance();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SightPointRedMouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
if (Button == mbRight) {
  SavX2 = X + SightPointRed->Left;
  SavY2 = Y + SightPointRed->Top;  	
  }
else SightPointRed->BringToFront();  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SightPointRedMouseMove(TObject *Sender,
	TShiftState Shift, int X, int Y)
{
long dx, dy;
if (Shift.Contains(ssRight)) {
  X += SightPointRed->Left;
  Y += SightPointRed->Top; 	
  dx = X - SavX2; dy = Y - SavY2;
  SightPointRed->X += dx;
  SightPointRed->Y += dy;
  SavX2 = X; SavY2 = Y;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SightPointBlackChange(TObject *Sender, int &NewX,
	int &NewY)
{
SpinEditBlackX->Value = NewX;	
SpinEditBlackY->Value = NewY;
EditDist->Text = StrDistance();	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SightPointBlackMouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
if (Button == mbRight) {
  SavX1 = X + SightPointBlack->Left;
  SavY1 = Y + SightPointBlack->Top;  	
  }
else SightPointBlack->BringToFront(); 	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SightPointBlackMouseMove(TObject *Sender,
	TShiftState Shift, int X, int Y)
{
long dx, dy;
TPoint pt;
if (Shift.Contains(ssRight)) {
  X += SightPointBlack->Left;
  Y += SightPointBlack->Top; 	
  dx = X - SavX1; dy = Y - SavY1;
  pt.x = SightPointBlack->Centre.x + dx;
  pt.y = SightPointBlack->Centre.y + dy;
  SightPointBlack->Centre = pt;
  SavX1 = X; SavY1 = Y;
  }	
}
//---------------------------------------------------------------------------
